#ifndef VORTEXLINE_H
#define VORTEXLINE_H

#include "VortexNode.h"
#include <qobject.h>


// Class for a Vortex Line Element;

class VortexLine
{
    friend class QLLTSimulation;
public:
    VortexLine();

    void    Update(double dT);
    void    SetGamma(double gamma);
    double  GetGamma();
    void    Delete();


//private:
    double Gamma;
    double VizGamma;          //for visualization purpose

    double Length;
    double oldLength;
    bool isTip, isHub;
    bool isTrailing, isShed;

    int fromTimestep;           //the timestep at which the panel was shed

    double age;
    double coreSizeSquared;
    double m_KinViscosity;
    double m_TurbulentViscosity;
    double m_VortexTimeOffset;

    int fromStation;            //the blade section at which the panel was shed

    bool isConcentrated;

    QList <VortexNode *> *m_Nodes;
    QList <VortexLine *> *m_Lines;

    VortexNode* pL;              //pointer to the LA node
    VortexNode* pT;              //pointer to the LB node
};

#endif // VORTEXLINE_H
